#ifndef MODE_H
#define MODE_H

#include "libflyadminmode_global.h"

#include <QObject>

namespace FlyAdmin
{

class LIBFLYADMINMODE_EXPORT Mode : public QObject
{
    Q_OBJECT
public:
    enum Licenses { orel, voronezh, smolensk, unknown };

    explicit Mode(QObject *parent = nullptr);

    /**
     * @brief getCurrentLicense Get current system mode (license)
     * @return current system mode (license)
     */
    Q_INVOKABLE static Licenses getCurrentMode();

    Q_INVOKABLE static QString getCurrentModeName();

    Q_INVOKABLE static bool setMode(int mode);
    Q_INVOKABLE static bool setMode(Licenses license);

    /**
     * @brief lastError Get last error
     * @return last error
     */
    Q_INVOKABLE static QString lastError();

    Q_INVOKABLE static QString toString(const QString &format = QStringLiteral("%level, \"%name\""));

private:
    static QString m_lastError;
};

}

#endif // MODE_H
